package com.sckw.contract.controller;

import com.alibaba.fastjson.JSON;
import com.sckw.contract.model.vo.req.*;
import com.sckw.contract.service.KwcContractTradeService;
import com.sckw.core.exception.SystemException;
import com.sckw.core.model.enums.EntTypeEnum;
import com.sckw.core.web.constant.HttpStatus;
import com.sckw.core.web.response.HttpResult;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.Valid;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Properties;


/**
 * @author czh
 * @desc 销售合同
 * @date 2023/7/13
 */
@RestController
@RequestMapping("kwcSale")
public class KwcContractSaleController {

    @Autowired
    private KwcContractTradeService kwcContractTradeService;

    /**
     * @desc: 分页查询
     * @param: reqVo 分页入参
     * @author: sky
     * @date 2023/7/17
     * @return HttpResult
     */
    @RequestMapping("queryListByPage")
    public HttpResult queryListByPage(@RequestBody QueryListReqVo reqVo) {
        reqVo.setEntType(EntTypeEnum.SUPPLIER.getCode());
        return HttpResult.ok(kwcContractTradeService.queryListByPage(reqVo));
    }

    /**
     * @param reqVo 新增入参
     * @return HttpResult
     * @desc: 新增贸易合同
     * @author: sky
     * @date: 2023/7/18
     */
    @RequestMapping("add")
    public HttpResult addTradeContract(@RequestBody ContractTradeReqVo reqVo) {
        kwcContractTradeService.addTradeContract(reqVo);
        return HttpResult.ok(HttpStatus.MSG_003);
    }

    /**
     * @param reqVo 补充入参
     * @desc: 补充合同
     * @author: czh
     * @date: 2023/7/14
     */
    @PostMapping("supplement")
    public HttpResult supplement(@Valid @RequestBody ContractTradeReqVo reqVo) {
        kwcContractTradeService.supplement(reqVo);
        return HttpResult.ok(HttpStatus.MSG_003);
    }

    /**
     * @desc: 合同详情
     * @param reqVo id
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("detail")
    public HttpResult detail(@Valid @RequestBody IdReqVo reqVo) {
        return HttpResult.ok(kwcContractTradeService.detail(reqVo.getId()));
    }


    /**
     * @desc: 发起签约
     * @param reqVo id
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("submit")
    public HttpResult submit(@Valid @RequestBody ContractTradeReqVo reqVo) {
        return HttpResult.ok(kwcContractTradeService.submit(reqVo));
    }

    /**
     * @desc: 修改草稿
     * @param reqVo id
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("update")
    public HttpResult update(@Valid @RequestBody ContractTradeReqVo reqVo) {
        kwcContractTradeService.update(reqVo);
        return HttpResult.ok();
    }


    /**
     * @desc: 手动完结
     * @param reqVo ids
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("complete")
    public HttpResult complete(@Valid @RequestBody CompleteReqVo reqVo) {
        kwcContractTradeService.complete(reqVo);
        return HttpResult.ok();
    }


    /**
     * @desc: 删除
     * @param reqVo ids
     * @author: czh
     * @date 2023/7/16
     * @return HttpResult
     */
    @PostMapping("delete")
    public HttpResult delete(@Valid @RequestBody IdsReqVo reqVo) {
        kwcContractTradeService.delete(reqVo.getIds());
        return HttpResult.ok();
    }


    /**
     * @desc: 导出
     * @param reqVo 查询入参
     * @author: czh
     * @date 2023/7/17
     */
    @PostMapping(value = "export", produces = MediaType.APPLICATION_JSON_VALUE)
    public void export(@Valid @RequestBody QueryListReqVo reqVo, HttpServletResponse response) {
        reqVo.setEntType(EntTypeEnum.SUPPLIER.getCode());
        kwcContractTradeService.export(reqVo, response);
    }

    /**
     * @return HttpResult
     * @desc: 查询当前企业的销售合同
     * @author: czh
     * @date: 2023/7/18
     */
    @PostMapping("queryCurrentEntSaleContractList")
    public HttpResult queryCurrentEntSaleContractList() {
        return HttpResult.ok(kwcContractTradeService.queryCurrentEntSaleContractList());
    }

    /**
     * @return HttpResult
     * @desc: 分组查询
     * @author: czh
     * @date: 2023/7/18
     */
    @PostMapping("findListGroup")
    public HttpResult findListGroup(@RequestBody QueryListReqVo reqVo) {
        reqVo.setEntType(EntTypeEnum.SUPPLIER.getCode());
        return HttpResult.ok(kwcContractTradeService.findListGroup(reqVo));
    }


    /**
     * @param reqVo 分页查询
     * @return HttpResult
     * @desc: 运营端查贸易合同
     * @author: czh
     * @date: 2023/9/13
     */
    @PostMapping("queryTradeByPage")
    public HttpResult queryTradeByPage(@RequestBody QueryListReqVo reqVo) {
        return HttpResult.ok(kwcContractTradeService.queryTradeByPage(reqVo));
    }

    /**
     * @return HttpResult
     * @desc: 分组查询
     * @author: czh
     * @date: 2023/7/18
     */
    @PostMapping("findTradeListGroup")
    public HttpResult findTradeListGroup(@RequestBody QueryListReqVo reqVo) {
        return HttpResult.ok(kwcContractTradeService.findTradeListGroup(reqVo));
    }

    /**
     * @param reqVo 查询参数
     * @desc: 运营端查贸易合同导出
     * @author: czh
     * @date: 2023/9/13
     */
    @PostMapping(value = "/exportTradeList", produces = MediaType.APPLICATION_JSON_VALUE)
    public void exportTradeList(@RequestBody QueryListReqVo reqVo, HttpServletResponse response) {
        kwcContractTradeService.exportTradeList(reqVo, response);
    }

}
